
library(SSRMST)
library(survRM2)

library(parallel)
require(multicore)   

simu=200


n=60


output<-array(100,dim=c(2096*3*2*4,12))

num=0

#shape0a=1

for(shape0a in c(0.5,1))
{
mins0<-round(22.5/gamma(1+1/shape0a/3.5))
s0vec<-mins0+c(0,2,6,10)

for(scale0v in s0vec)
{

#scale0v=20
#if(shape0a>1.5){scale0v=22}
#if(shape0a<0.8){scale0v=15}

TIEout<-array(,dim=c(simu,10))
Powerout<-array(,dim=c(simu,10))



TIE<-function(j)
{
TIEouta<-c()

tgroup1<-rweibull(n,shape1,scale1)
tgroup0<-rweibull(n,shape0,scale0)

timeL<-rweibull(2*n,shape=1,scale=80)

#time of observing events
timeO<-c(tgroup1,tgroup0)

# patient enroll time calendar
Enroll=12
delta<-10^(-5)
timeE1<-sample(seq(delta, Enroll-delta,length=n))
timeE0<-sample(seq(delta, Enroll-delta,length=n))
timeE<-c(timeE1,timeE0)

#time for patient accrual time =enroll
timeA=Enroll

# total time
timeT=36

# Follow up time prespecified 2 years
timeF<- timeT - timeA

#time check
timeC<-timeT

timeC-timeE

    ctime=rexp(n)/0.014*12
    timeZ=pmin(timeO, timeL, timeC-timeE)

arm<-c(rep(1,times=n),rep(0,times=n))

status<-c()
for(i in 1:(2*n))
{
status[i]=1
if((timeO[i]+timeE[i])>timeC){status[i]=0}else{
if(timeL[i]<timeO[i]){status[i]=0}
   }
if(timeZ[i]>(timeC-timeA) & status[i]>0.5){status[i]=0}
}

a<-rmst2(timeZ, status, arm, tau=timeF)

#plot(a)

RMSTd=a$unadjusted.result
RMSTd[1,1]
RMSTd

TIEouta[c(1:2)]<-c((-RMSTd[1,1]),RMSTd[1,4])
TIEouta[10]<-j

## logrank test and Wilcoxon test

datanew<-array(10,dim=c(length(timeZ),5))
datanew[,1]<-timeZ
datanew[,2]<-status
datanew[,3]<-arm
datanew[,4]<-timeF
datanew<-data.frame(datanew)
colnames(datanew)<-c("timeZ","status","arm","timeF","temp")

surv_diff <- survdiff(Surv(timeZ, status) ~ arm, data = datanew,rho = 0 )
surv_diff
surv_diff$chisq


TIEouta[c(3:4)]<-c(sign(surv_diff$obs[2]-surv_diff$exp[2])*surv_diff$chisq,1-pchisq(surv_diff$chisq,df=1))

surv_Wilcoxon <- survdiff(Surv(timeZ, status) ~ arm, data = datanew,rho=1)
surv_Wilcoxon



TIEouta[c(5:6)]<-c(sign(surv_Wilcoxon$obs[2]-surv_Wilcoxon$exp[2])*surv_Wilcoxon$chisq,1-pchisq(surv_Wilcoxon$chisq,df=1))

## cox PH  HR=exp(coef) if HR<1 that means 
# group=1 is better than group=0 with low rate

cox_diff<-coxph(Surv(timeZ,status) ~ arm, data=datanew)
cox_diff

TIEouta[c(7:9)]<- summary(cox_diff)$coefficient[c(1,5,2)]



if(is.numeric(TIEouta))
{
return(TIEouta)
}else{
TIEouta<-rep(2000010,times=10)
return(TIEouta)
}

}

## compute TIE


shape0=shape0a
scale0=scale0v
shape1=shape0a
scale1=scale0v

#for(k in 1:simu)
#{
#TIEout[k,]<-TIE(k)
#}


pointT3<-c(1:simu)

lpointT3<-length(pointT3)


Est100<-mclapply(pointT3, TIE, mc.cores=1) 

dim(Est100)

aabb<-matrix(unlist(Est100),nrow=lpointT3,byrow=T)

TIEoutabc<-aabb

TIEout<-TIEoutabc[which(TIEoutabc[,10]<(simu+10)),]


TIEout<-data.frame(TIEout)
colnames(TIEout)<-c("RMST","RMSTp","LogRank","LogRankp","Wilcoxon","Wilcoxonp","Cox","Coxp","Coxbest","Simu")
TIEout


## compute power



#shape1v<-c(0.6,0.8,1,1.2,1.5,2)
#if(shape0a>1.5){shape1v<-c(1.2,1.5,2,2.5,3,4)}
#if(shape0a<0.8){shape1v<-c(0.3,0.5,0.8,1,1.2,1.5)}

#shape1v<-c(0.8,1,1.5)
shape1v<-c(0.8,1,1.5)*shape0a

#scale1v<-c(20,25,30)
#if(shape0a>1.5){scale1v<-c(25,28,32)}
#if(shape0a<0.8){scale1v<-c(18,20,25)}

scale1v<-scale0v+c(0,2,5,10)

for(scale1a in scale1v)
for(shape1a in shape1v)
{

num=num+1
shape0=shape0a
scale0=scale0v
shape1=shape1a
scale1=scale1a

print(c(shape0,scale0,shape1,scale1))

#for(k in 1:simu)
#{
#Powerout[k,]<-TIE(k)
#}


pointT3<-c(1:simu)

lpointT3<-length(pointT3)


Est100<-mclapply(pointT3, TIE, mc.cores=1) 

dim(Est100)

aabb<-matrix(unlist(Est100),nrow=lpointT3,byrow=T)

Poweroutabc<-aabb

print(dim(Poweroutabc))
#print(head(Poweroutabc))
#print(tail(Poweroutabc))

Powerout<-Poweroutabc[which(Poweroutabc[,10]<(simu+10)),]


Powerout<-data.frame(Powerout)
colnames(Powerout)<-c("RMST","RMSTp","LogRank","LogRankp","Wilcoxon","Wilcoxonp","Cox","Coxp","Coxbest","Simu")
head(Powerout)

## all values the smaller the better the new treatment is

for(ij in c(1,3,5,7))
{
cut=quantile(TIEout[,ij],probs=0.05,na.rm =T)
power=mean(Powerout[,ij]<cut,na.rm = T)
output[num,(ij+1)/2]<-power
output[num,(ij+1)/2+4]<-cut
}
output[num,9]<-shape0
output[num,10]<-shape1
output[num,11]<-scale0
output[num,12]<-scale1

if(num>1.5){
print(output[num,])
}

outputf<-output[1:num,]

shape0b=shape0*10
ccc <- paste("/home/RMST2/Test","change1210a.txt",sep="") 
filena<-ccc

write.table(outputf,filena,row.names=F,col.names=F,append=F)


}



}
}

